# -*- coding: utf-8 -*-

import os, sys
from PyQt4 import QtCore, QtGui
from PyQt4.Qt import Qt, QImage, QPixmap, QString, QWidget
import logging
import signal

from ui.welcome_window_ui import  Ui_Welcome_window
from select_files_window import SelectFilesWindow

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s

_PREVIOUS="previous"
_NEXT="next"
_PAGED="<html><head/><body><pPágina %s de 2\></body>"


class DialogWindow(QtGui.QWidget):
    
    accepted_signal = QtCore.pyqtSignal()
    abort_signal = QtCore.pyqtSignal()
    
    def __init__(self, parent=None):
        super(DialogWindow, self).__init__(parent)
        
        self.window = Ui_Welcome_window()
        self.window.setupUi(self)
        self.setFixedSize(self.size())
        _windowButtons = QtCore.Qt.Window | QtCore.Qt.WindowStaysOnTopHint | QtCore.Qt.CustomizeWindowHint  | QtCore.Qt.WindowSystemMenuHint & ~ QtCore.Qt.WindowCloseButtonHint
        
        self.setWindowFlags(_windowButtons)
        
        #situamos la ventana en el centro de la pantalla
        screen = QtGui.QDesktopWidget().screenGeometry()
        size = self.geometry()
        self.resize(1024,600)
        self.move((screen.width()- size.width())/2, (screen.height()-size.height())/2)
        
        self.window.pushButton_next.clicked.connect(self.next)
        self.window.pushButton_previous.clicked.connect(self.previous)
        self.window.pushButton_abort.clicked.connect(self.abbort)
        
        self._1DE2 = unicode("Página 1 de 2", "UTF-8")
        self._2DE2 = unicode("Página 2 de 2", "UTF-8")  
        
        self.step=0
        self.window.text_2.hide()
        self.window.text_paged.setText(self._1DE2)
        self.window.text_paged.show()
        
        
    def next(self,event):
        self.accept(_NEXT)
        
    def previous(self, event):
        self.accept(_PREVIOUS)
        
    def abbort(self,event):
        self.hide()
        self.abort_signal.emit()
        
    def accept(self, button):
        # paso 0, siguiente habilitado
        if self.step == 0:
            self.step = 1
            self.window.text_1.hide()
            self.window.text_2.show()
            self.window.pushButton_previous.setEnabled(True)
            self.window.pushButton_abort.setEnabled(True)
            self.window.text_paged.setText(self._2DE2)
        elif self.step == 1 and button==_PREVIOUS:
            self.step = 0
            self.window.text_2.hide()
            self.window.text_1.show()
            self.window.pushButton_abort.setEnabled(False)
            self.window.text_paged.setText(self._1DE2)
        elif self.step == 1 and button==_NEXT:
            self.hide()
            self.accepted_signal.emit()
        
    def open_url(self, URL):
        QtGui.QDesktopServices().openUrl(QUrl(URL))
        
if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG)
    signal.signal(signal.SIGINT, signal.SIG_DFL)
    
    app = QtGui.QApplication(sys.argv)
    file_w = SelectFilesWindow()
    file_w.set_path("/tmp/")
    
    def abortar():
        logging.debug("abortar!")
    
    dialog_w = DialogWindow()
    dialog_w.accepted_signal.connect(file_w.show)
    dialog_w.abort_signal.connect(abortar)
    
    dialog_w.show()
    
    sys.exit(app.exec_())