# -*- coding: utf-8 -*-

import os, sys
from PyQt4 import QtCore, QtGui
from PyQt4.Qt import Qt
import logging

from ui.log_out_ui import Ui_LogOut

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s
    
    
class Log_out(QtGui.QWidget):
    accept_clicked = QtCore.pyqtSignal()
    timeout_expired_signal = QtCore.pyqtSignal()
    
    def __init__(self, seconds, parent=None):
        super(Log_out, self).__init__(parent)
        
        self.ui = Ui_LogOut()
        self.ui.setupUi(self)
        
        __windowButtons = QtCore.Qt.Window | QtCore.Qt.WindowStaysOnTopHint | QtCore.Qt.CustomizeWindowHint  | QtCore.Qt.WindowSystemMenuHint & ~ QtCore.Qt.WindowCloseButtonHint
        self.setWindowFlags(__windowButtons)
        
        #situamos la ventana en el centro de la pantalla
        screen = QtGui.QDesktopWidget().screenGeometry()
        size = self.geometry()
        self.move((screen.width()- size.width())/2, (screen.height()-size.height())/2)
        
        # señales
        self.ui.pushButton.clicked.connect(self.__accept_button_pushed)
        
        self.__timer_text = "La sesión se cerrará en %s segundos"
        self.__seconds = seconds
        self.set_seconds_timer(self.__seconds)
        
        self.show()
        
    def start_timeout(self):
         # instanciamos el timer
        self.__timer = QtCore.QTimer()
        self.__timer.setSingleShot(True)
        self.__timer.setInterval(1000)
        self.connect(self.__timer,
                     QtCore.SIGNAL("timeout()"),
                     self.__shoot)
        self.__timer.start()
    
    def __shoot(self):
        self.__seconds -= 1
        self.set_seconds_timer(self.__seconds)
        if self.__seconds <= 0:
            logging.debug("Se acabo el timer!")
            self.__timeout_accept_handler()
        else:
            self.__timer.start()
    
    def set_seconds_timer(self, seconds):
        qstring = _fromUtf8(self.__timer_text %seconds)
        self.ui.label_timeout.setText(qstring)
        
    def __accept_button_pushed(self, event):
        self.accept_clicked.emit()
        
        
    def set_timeout_accept_handler(self, handler):
        self.__timeout_accept_handler = handler
        self.accept_clicked.connect(handler)
  
        
if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG,
                        format='%(levelname)s %(asctime)-15s %(module)s %(filename)s:%(lineno)d - %(message)s')
    
    app = QtGui.QApplication(sys.argv)
    time = 5
    
    app_gui = Log_out(time)
    
    def handler():
        logging.debug( "FIN!")
        app_gui.hide()
        app.quit()
        
    app_gui.set_timeout_accept_handler(handler)
    app_gui.start_timeout()
    
    sys.exit(app.exec_())
