# -*- coding: utf-8 -*-

import os, sys
from PyQt4 import QtCore, QtGui
from PyQt4.Qt import Qt
import signal
import logging

from ui.power_off_ui import Ui_PoweringOff


try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s
    
    
class Powering_off(QtGui.QWidget):
    timeout_expired_signal = QtCore.pyqtSignal()

    
    def __init__(self, parent=None):
        super(Powering_off, self).__init__(parent)
        
        self.ui = Ui_PoweringOff()
        self.ui.setupUi(self)
        
        self.__acum = 0
        self.__update_ratio = 25/15
        self.__time = 115
        self.__timer = QtCore.QTimer()
        self.__timer.setInterval(self.__time)
        
        self.ui.progressBar.setValue(100)
        self.ui.progressBar.setTextVisible(False)
        
        screen = QtGui.QDesktopWidget().screenGeometry()
        size = self.geometry()
        self.move((screen.width()- size.width())/2, (screen.height()-size.height())/2)
        _windowButtons = QtCore.Qt.Window | QtCore.Qt.WindowStaysOnTopHint | QtCore.Qt.CustomizeWindowHint  | QtCore.Qt.WindowSystemMenuHint & ~ QtCore.Qt.WindowCloseButtonHint
        self.setWindowFlags(_windowButtons)
    
    
    def start_timer(self):
#        logging.debug("empieza el timer!")
        if not self.isVisible():
            self.show()
        self.__timer.singleShot(self.__time,
                                self.__update_progress)
    
    def set_value(self, value):
        self.ui.progressBar.setValue(value)
        
    def get_value(self):
        return self.ui.progressBar.value()
    
    def __update_progress(self):
        new_value = self.get_value()-self.__update_ratio
        if  new_value >= 0:
            self.set_value(new_value)
            self.start_timer()
        else:
            self.hide()
            logging.debug("finaliza el timer, ¡pido reiniciar!")
            self.timeout_expired_signal.emit()
    

        
if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG,
                        format='%(levelname)s %(asctime)-15s %(module)s %(filename)s:%(lineno)d - %(message)s')
    
    app = QtGui.QApplication(sys.argv)
    app_gui = Powering_off()
    def handler():
        logging.debug("Señal recibida!!!")
        sys.exit(0)
    app_gui.set_handler(handler)
    logging.debug("Empieza")
#    app_gui.show()
    app_gui.start_timer()
    
    sys.exit(app.exec_())
